/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"bytes"
	"encoding/json"
	"fmt"
)

// checks if the ApplicationBlockingRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ApplicationBlockingRequest{}

// ApplicationBlockingRequest struct for ApplicationBlockingRequest
type ApplicationBlockingRequest struct {
	Enabled        bool           `json:"enabled"`
	BlockingReason NullableString `json:"blockingReason,omitempty"`
}

type _ApplicationBlockingRequest ApplicationBlockingRequest

// NewApplicationBlockingRequest instantiates a new ApplicationBlockingRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewApplicationBlockingRequest(enabled bool) *ApplicationBlockingRequest {
	this := ApplicationBlockingRequest{}
	this.Enabled = enabled
	return &this
}

// NewApplicationBlockingRequestWithDefaults instantiates a new ApplicationBlockingRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewApplicationBlockingRequestWithDefaults() *ApplicationBlockingRequest {
	this := ApplicationBlockingRequest{}
	return &this
}

// GetEnabled returns the Enabled field value
func (o *ApplicationBlockingRequest) GetEnabled() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Enabled
}

// GetEnabledOk returns a tuple with the Enabled field value
// and a boolean to check if the value has been set.
func (o *ApplicationBlockingRequest) GetEnabledOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Enabled, true
}

// SetEnabled sets field value
func (o *ApplicationBlockingRequest) SetEnabled(v bool) {
	o.Enabled = v
}

// GetBlockingReason returns the BlockingReason field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ApplicationBlockingRequest) GetBlockingReason() string {
	if o == nil || IsNil(o.BlockingReason.Get()) {
		var ret string
		return ret
	}
	return *o.BlockingReason.Get()
}

// GetBlockingReasonOk returns a tuple with the BlockingReason field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ApplicationBlockingRequest) GetBlockingReasonOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.BlockingReason.Get(), o.BlockingReason.IsSet()
}

// HasBlockingReason returns a boolean if a field has been set.
func (o *ApplicationBlockingRequest) HasBlockingReason() bool {
	if o != nil && o.BlockingReason.IsSet() {
		return true
	}

	return false
}

// SetBlockingReason gets a reference to the given NullableString and assigns it to the BlockingReason field.
func (o *ApplicationBlockingRequest) SetBlockingReason(v string) {
	o.BlockingReason.Set(&v)
}

// SetBlockingReasonNil sets the value for BlockingReason to be an explicit nil
func (o *ApplicationBlockingRequest) SetBlockingReasonNil() {
	o.BlockingReason.Set(nil)
}

// UnsetBlockingReason ensures that no value is present for BlockingReason, not even an explicit nil
func (o *ApplicationBlockingRequest) UnsetBlockingReason() {
	o.BlockingReason.Unset()
}

func (o ApplicationBlockingRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ApplicationBlockingRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["enabled"] = o.Enabled
	if o.BlockingReason.IsSet() {
		toSerialize["blockingReason"] = o.BlockingReason.Get()
	}
	return toSerialize, nil
}

func (o *ApplicationBlockingRequest) UnmarshalJSON(data []byte) (err error) {
	// This validates that all required properties are included in the JSON object
	// by unmarshalling the object into a generic map with string keys and checking
	// that every required field exists as a key in the generic map.
	requiredProperties := []string{
		"enabled",
	}

	allProperties := make(map[string]interface{})

	err = json.Unmarshal(data, &allProperties)

	if err != nil {
		return err
	}

	for _, requiredProperty := range requiredProperties {
		if _, exists := allProperties[requiredProperty]; !exists {
			return fmt.Errorf("no value given for required property %v", requiredProperty)
		}
	}

	varApplicationBlockingRequest := _ApplicationBlockingRequest{}

	decoder := json.NewDecoder(bytes.NewReader(data))
	decoder.DisallowUnknownFields()
	err = decoder.Decode(&varApplicationBlockingRequest)

	if err != nil {
		return err
	}

	*o = ApplicationBlockingRequest(varApplicationBlockingRequest)

	return err
}

type NullableApplicationBlockingRequest struct {
	value *ApplicationBlockingRequest
	isSet bool
}

func (v NullableApplicationBlockingRequest) Get() *ApplicationBlockingRequest {
	return v.value
}

func (v *NullableApplicationBlockingRequest) Set(val *ApplicationBlockingRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableApplicationBlockingRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableApplicationBlockingRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableApplicationBlockingRequest(val *ApplicationBlockingRequest) *NullableApplicationBlockingRequest {
	return &NullableApplicationBlockingRequest{value: val, isSet: true}
}

func (v NullableApplicationBlockingRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableApplicationBlockingRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
